<?php
/*
Plugin Name: wp-einsatz
Plugin Script: wp-einsatz.php
Plugin URI: http://file.fw-gz.de/plugins/
Description: Einsatzliste und Widget fuer Feuerwehren
Version: 0.3
Author: Stefan Hauf
Author URI: http://www.feuerwehr-guenzburg.de
*/

setlocale(LC_TIME, 'de_DE');
// Erstellt die Tabelle beim ersten Start
function install () {
  global $wpdb;
   
  $table_name = $wpdb->prefix . "einsaetze";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {      
    $sql = "CREATE TABLE " . $table_name . " (
	    ID mediumint(9) NOT NULL AUTO_INCREMENT,
	    Datum datetime NOT NULL default '0000-00-00 00:00:00',
	    Ort varchar(100) NOT NULL default '',
	    Art varchar(100) NOT NULL default '',
	    UNIQUE KEY ID (ID)
	    );";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
    $insert = "INSERT INTO $table_name (Datum, Ort, Art) VALUES (NOW(), 'Musterstadt', 'Fehlalarm')";
    $results = $wpdb->query( $insert );
  }
}
register_activation_hook(__FILE__,'install');

//  Fgt das CSS-File in den Header ein
function addHeaderCode() {
  echo '<link type="text/css" rel="stylesheet" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/wp-einsatz/wp-einsatz.css" />' . "\n";		
}
add_action('wp_head', 'addHeaderCode', 1);	      

function einsatz_liste($content, $edit, $start) {
  global $wpdb;  
  $table_name = $wpdb->prefix . "einsaetze";
  $limit = "";
  $count = $wpdb->get_var("SELECT COUNT(*) FROM $table_name");
  if ($edit == 1) {  
    $limit = " LIMIT $start, 10";
    echo "<table border='0'><tr><td>Eins&auml;tze beginnend ab:</td><td>\n";

    for ($i = 0; $i < $count/10; $i++) {
      $next  = $i*10;
      if ($start == $next)
        echo "<td><b><form method=\"post\"><input style=\"font-weight: bold;\" type=\"reset\" name=\"start\" value=\"-".$next."-\" /></form></b></td>";
      else
        echo "<td><form method=\"post\"><input type=\"submit\" name=\"start\" value=\"".$next."\" /></form></td>";
    }
    echo "</tr></table>\n";
    
  }  
  
  $html  = "<table class='einsatzliste' border='1'>\n";
  $html .= "  <tr>\n";
  $ueberschriften = $wpdb->get_results("SHOW COLUMNS FROM $table_name");
  foreach ($ueberschriften as $ueberschrift) {
    $field = $ueberschrift->Field;
    if ($field == "ID") continue; // ignore ID
    $html .= "    <th>".$field."</th>\n";         
    if ($field == "Datum")
      $html .= "    <th>Uhrzeit</th>\n";
    else          
      $fields[] = $field;
  }
  if ($edit == 1) {
    $html .= "    <th>&Auml;ndern</th>\n";
    $html .= "    <th>L&ouml;schen</th>\n";
  }

  $html .= "  </tr>\n";
  
  $jahr = $wpdb->escape(get_post_meta(get_the_ID(),'jahr',TRUE));
  if (strlen($jahr) == 4) {
    $einsaetze = $wpdb->get_results("SELECT *, DATE_FORMAT(Datum, '%d. %b') AS Datum_F, DATE_FORMAT(Datum, '%H:%i') AS Uhrzeit FROM $table_name WHERE YEAR(Datum) = '$jahr' ORDER BY Datum ASC$limit", ARRAY_A);
  }
  else {                            
    $einsaetze = $wpdb->get_results("SELECT *, DATE_FORMAT(Datum, '%d. %b') AS Datum_F, DATE_FORMAT(Datum, '%H:%i') AS Uhrzeit FROM $table_name ORDER BY Datum ASC$limit", ARRAY_A);
  }
  foreach ($einsaetze as $einsatz) {    
    $i++;
    $html .= ($i%2) ? "  <tr>\n" : "  <tr class='alt'>\n";
    $html .= "    <td>".$einsatz['Datum_F']."</td>\n";
    $html .= "    <td>".$einsatz['Uhrzeit']."</td>\n";
    foreach ($fields as $field) {
      $html .= "    <td>".$einsatz[$field]."</td>\n";
    }          
    if ($edit == 1) {
      $html .= "    <td><form method=\"post\" id=\"edit\"  ><fieldset class=\"options\"><input type=\"hidden\" name=\"ID\" value=\"".$einsatz['ID']."\"><input type=\"submit\" name=\"edit\"   value=\"&Auml;ndern\"  /></fieldset></form></td>";
      $html .= "    <td><form method=\"post\" id=\"delete\"><fieldset class=\"options\"><input type=\"hidden\" name=\"ID\" value=\"".$einsatz['ID']."\"><input type=\"submit\" name=\"delete\" value=\"L&ouml;schen\" /></fieldset></form></td>";        
    }
    $html .= "  </tr>\n";
  }	 
  $html .= "</table>\n";
  return $html;
}

function einsatz_filter($content) {
  $html = einsatz_liste($content, 0);
  if (get_option('blog_charset') == "UTF-8") 
    $content = eregi_replace( '<!--einsatzliste-->', utf8_encode($html), $content );
  else
    $content = eregi_replace( '<!--einsatzliste-->', $html, $content );
  return $content;
  
}
add_filter('the_content', 'einsatz_filter');


function einsatz_adminliste() {
  global $wpdb;   
  $table_name = $wpdb->prefix . "einsaetze";
  if($_POST['delete']) {
    $wpdb->query("DELETE FROM $table_name WHERE ID = ".$_POST['ID']." LIMIT 1");
    echo "<div class='updated'><p>Einsatz wurde erfolgreich gel&ouml;scht.</p></div>";
  }
  if($_POST['update']) {
    $sql = "UPDATE $table_name SET "; 
    foreach ($_POST as $key => $value) {    
      if ($key == "ID" || $key == "update") continue;
      $sql .= "$key = \"$value\", ";
    }
    $sql   = substr($sql,0,-2);    
    $sql .= " WHERE ID = ".$_POST['ID']." LIMIT 1";  
    
    if (get_option('blog_charset') == "UTF-8")
      $sql=utf8_decode($sql);
      
    //Aktion ausfhren      
    $wpdb->query($sql);
    
    echo "<div class='updated'><p>Einsatz wurde erfolgreich aktualisiert.</p></div>";
  }

  if($_POST['edit']) {
    $sql = "SELECT * FROM $table_name WHERE ID = ".$_POST['ID']." LIMIT 1";       
    $einsatz = $wpdb->get_row($sql, ARRAY_A);
    
    
    $html  = "<table>\n  <form METHOD='POST'>\n";
    foreach ($einsatz as $key => $value) {
      $type = "text";      
      if ($key == "ID")  {
        $type = "hidden";
        $html .= "<input name='$key' value='$value' type='$type'>";
      }
      else {
        $html .= "<tr><td>$key</td><td><input name='$key' value='$value' type='$type'></td></tr>\n";
      }    
    }
    $html .= "    <tr><td>&nbsp;</td><td><input type='submit' name='update'></td></tr>\n  </form>\n</table>\n";
    
    if (get_option('blog_charset') == "UTF-8") 
     $html = utf8_encode($html);
    
    echo $html;
  }
  else {
    if (!isset($_POST["start"])) $start = 0;
    else                         $start = $_POST["start"];
    
    $html = einsatz_liste("", 1, $start);
    if (get_option('blog_charset') == "UTF-8") 
      echo utf8_encode($html);
    else
      echo $html;
  }
}

function einsatz_new() {
  global $wpdb;  
  $table_name = $wpdb->prefix . "einsaetze";
  
  if($_POST['new']) {
  
    foreach($_POST as $key=>$value) {
      if ($value!='' && $key!="new") {
        $keys .= "$key, ";
        $values .= "'$value', ";
      }
    }
    $keys   = substr($keys,0,-2);
    $values = substr($values,0,-2);
    $sql = "INSERT INTO $table_name ($keys) VALUES ($values)";
    
    if (get_option('blog_charset') == "UTF-8")
      $sql=utf8_decode($sql);
      
    $results = $wpdb->query($sql);
    echo "<div class='updated'><p>Einsatz wurde erfolgreich eingetragen.</p></div>";
  }
  $date = $wpdb->get_var("SELECT NOW()");
     
  $html  = "<table>\n  <form METHOD='POST'>\n";
  $ueberschriften = $wpdb->get_results("SHOW COLUMNS FROM $table_name");
  foreach ($ueberschriften as $ueberschrift) {
    $field = $ueberschrift->Field;
    $default = $ueberschrift->Default;
    if ($field == "ID") continue; // ignore ID             
    if ($field == "Datum")
      
      $html .= "    <tr><td>$field</td><td><input name='$field' type='text' value='".$date."'></td></tr>\n";
    else    
      $html .= "    <tr><td>$field</td><td><input name='$field' type='text' value='$default'></td></tr>\n";
  }
  $html .= "    <tr><td>&nbsp;</td><td><input type='submit' name='new'></td></tr>\n  </form>\n</table>";
  echo $html;
}

//  Erstellen der Menus und deren Anzeige im wp-Adminbereich
function einsatz_menu() {
  add_menu_page('Eins&auml;tze', 'Eins&auml;tze', 8, __FILE__, 'einsatz_adminliste');
  add_submenu_page(__FILE__, 'Neuer Einsatz', 'Neuer Einsatz', 8, 'sub-page', 'einsatz_new');
}
add_action('admin_menu', 'einsatz_menu');


function einsatz_widget_init() 
{
  function einsatz_widget_list() 
  {
    global $wpdb;
    $table_name = $wpdb->prefix . "einsaetze";

    $einsatz = $wpdb->get_row("SELECT *, DATE_FORMAT(Datum, '%d. %b %H:%i') AS Datum_F FROM $table_name ORDER BY Datum DESC LIMIT 1");

    echo "<li id=\"archives\" class=\"widget widget_archive\"><h2 class=\"widgettitle\">Letzter Einsatz</h2>";
    echo utf8_encode("<ul><li><a href='".get_settings('home')."/einsatz/'>".$einsatz->Datum_F."<br>".$einsatz->Ort."<br>".$einsatz->Art."</a></li></ul></li>\n");
  }

  register_sidebar_widget(
    array(__('Lezter Einsatz','einsatz'),'widgets'),
    'einsatz_widget_list'
  );
  register_widget_control(
    array(__('Letzter Einsatz','einsatz'),'widgets'),
    'einsatz_widget_list_control'
  );
}

add_action('widgets_init', 'einsatz_widget_init');
?>
